#include <stdio.h>
#include <math.h>
#include "mpmath.h"

#define IMIN(x,y) (((x) < (y)) ? (x) : (y))
#define MF 3
#define RX 10000.0
#define BI (1.0/RX)

void mpinv(short y[], short x[], short a[], int n9, int flags)
{
    static short *u;
    int i,j,mm,isign,n=n9,k,k9;
    double fu,fv;

    if (flags==GRAB) {
		printf("mpinv   allocating %9d bytes\n",n*sizeof(short));
		u=ivector(n);
		return;
	}
    if (flags==FREE) {
		free_ivector(u);
		return;
	}

    mm=IMIN(n,MF);
    fv=(double) a[mm];
//  for (j=mm-1;j>=0;j--) {
    for (j=n9-1;j>=0;j--) {
        fv *= BI;
        fv += a[j];
    }
    fu=1.0/fv;
    for (j=0;j<n;j++) {
        i=(int) fu;
        x[j]=(short) i;
        fu=RX*(fu-i);
    }

	for (n=4;n<n9;n*=2) {
		if (n==n9/4) k9=2; else k9=1;
		for (k=0;k<k9;k++) {
    
	    //    x = x + x  ( 1 - A  x )

	    //------------------------------------
	    //  u = a  x
		//------------------------------------

		fullmul(u,a,x,n,n,LSH);

		//------------------------------------
		//  u = 1 - u
		//------------------------------------

		if (u[0]==0) {
			mpneg(u,n);
	        u[0]-=9999;
		    isign = +1;
	    } else {
		    u[0]--;
			isign = -1;
		}

		//------------------------------------
	    //  u = x  u
		//------------------------------------

	    fullmul(u,x,u,n,n,LSH);

		//------------------------------------
	    //  x = x + u
		//------------------------------------

	    if (isign == +1)
		    mpadd(x,x,u,n);
		else    
			mpsub(x,x,u,n);
		}
	}

    n=n9;

    //  y = x
    
    //  y = y + x  ( 1 - A  y) / 2

    //------------------------------------
    //  y = x
    //------------------------------------

    mpmov(y,x,n);

    //------------------------------------
    //  u = a  y
    //------------------------------------

    fullmul(u,a,x,n,n,LSH);

    //------------------------------------
    //  u = 1 - u
    //------------------------------------

    if (u[0]==0) {
        mpneg(u,n);
        u[0]-=9999;
        isign = +1;
    } else {
        u[0]--;
        isign = -1;
    }

    //------------------------------------
    //  u = x  u
    //------------------------------------

    halfmul(u,x,u,n,n,0);

    //------------------------------------
    //  y = y + u
    //------------------------------------

    if (isign == +1)
        mpadd(y,y,u,n);
    else
        mpsub(y,y,u,n);

    //------------------------------------
    // end
    //------------------------------------

    return;
}
